%define 	nvidialibdir %{_libdir}/nvidia
%define 	nvidialib32dir %{_prefix}/lib/nvidia
%define     	nvversion 173.14.27

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Proprietary NVIDIA hardware accelerated OpenGL display driver
Name: 		dkms-nvidia-legacy173xx-x11-drv
Version: 	1.0.173.14.22
Release: 	1
License: 	Proprietary
Group: 		System/Configuration/Hardware
URL: 		http://www.nvidia.com/object/unix.html
# X86
Source0: 	http://us.download.nvidia.com/XFree86/Linux-x86/%{nvversion}/NVIDIA-Linux-x86-%{nvversion}-pkg0.run
# x86_64
Source1: 	http://us.download.nvidia.com/XFree86/Linux-x86_64/%{nvversion}/NVIDIA-Linux-x86_64-%{nvversion}-pkg2.run
Source202: 	nvidia.sh
Source203: 	nvidia.csh
Source205: 	nvidia.modprobe
Source206: 	nvidia.nodes
# http://www.nvnews.net/vbulletin/attachment.php?attachmentid=20486&d=1158955681
Patch0: 	NVIDIA_kernel-1.0-9625-NOSMBUS.diff.txt
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildArch:	i686
ExclusiveArch: 	i686 x86_64
# Required by the NVIDIA run file
Buildrequires: 	tar
# Required for our build
BuildRequires: 	desktop-file-utils
# Required for proper dkms operation
Requires: 	gcc, make
Requires(post): dkms, /sbin/ldconfig
Requires(preun): dkms
Provides: 	dkms-nvidia = %{version}-%{release}
Provides:	xorg-x11-drv-nvidia = %{version}-%{release}
Obsoletes:	xorg-x11-drv-nvidia < %{version}-%{release}
Provides:	kmod-nvidia = %{version}-%{release}
Obsoletes:	kmod-nvidia < %{version}-%{release}
Obsoletes:	kmod-nvidia-PAE < %{version}-%{release}

BuildConflicts: dkms-nvidia-x11-drv
BuildConflicts: dkms-nvidia-legacy96xx-x11-drv
BuildConflicts: dkms-fglrx-x11-drv
Conflicts:      dkms-nvidia-x11-drv
Conflicts:      dkms-nvidia-legacy96xx-x11-drv

#Automatically resolved build dependencies
BuildRequires: 	atk-devel
BuildRequires: 	bash
BuildRequires: 	glibc-devel
BuildRequires: 	glib-devel
BuildRequires: 	gtk2+-devel
BuildRequires: 	libX11-devel
BuildRequires: 	libXext-devel
BuildRequires: 	mesa-libGL-devel
BuildRequires: 	pango-devel
BuildRequires: 	xorg-x11-server-Xorg
BuildRequires: 	zlib-devel
BuildRequires: 	libvdpau-devel

%description
Proprietary NVIDIA GL libraries, Xorg and Linux module for hardware
accelerated OpenGL support.

INSTALLING THIS PACKAGE WILL TAINT YOUR KERNEL, SO PLEASE DO NOT REPORT *ANY*
BUGS BEFORE YOU UNINSTALL THE PACKAGE AND REBOOT THE SYSTEM.

%package 32bit
Summary: 	Compatibility 32bit files for the 64bit Proprietary NVIDIA driver
Group: 		System/Configuration/Hardware
Requires: 	%{name} = %{version}-%{release}

%description 32bit
Compatibility 32bit files for the 64bit Proprietary NVIDIA driver.

%prep
%setup -T -c
# Extract the proper "sources" for the current architecture
# We need to extract to a "not yet existing" directory first, so no "."
%ifarch i686
sh %{SOURCE0} --extract-only --target tmp/
%endif
%ifarch x86_64
sh %{SOURCE1} --extract-only --target tmp/
%endif
# Move all the files back from tmp/ to the main directory
%{__mv} tmp/* .
%{__rm} -rf tmp/
#%patch0 -p0

%build

%install
%{__rm} -rf %{buildroot}

%define dkms_name nvidia-legacy173xx
%define dkms_vers %{version}-%{release}
%define quiet -q

# Copy dkms conf file
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cat} > %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf << 'EOF'
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="make module KERNDIR=/lib/modules/$kernelver IGNORE_CC_MISMATCH=1 SYSSRC=$kernel_source_dir"
BUILT_MODULE_NAME[0]=nvidia
DEST_MODULE_LOCATION[0]=/kernel/drivers/video/nvidia
AUTOINSTALL=YES
EOF

# Install all the files, even the binary ones. Ick.
%{__install} -p -m 0644 usr/src/nv/{*.c,*.h,*.o,makefile,Makefile.kbuild} \
    %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__install} -p -m 0755 usr/src/nv/*.sh \
    %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Install libXvMCNVIDIA.*
%{__mkdir_p} %{buildroot}%{nvidialibdir}/
%{__install} -p -m 0755 usr/X11R6/lib/libXvMCNVIDIA.so.* \
    %{buildroot}%{nvidialibdir}/
%{__install} -p -m 0644 usr/X11R6/lib/libXvMCNVIDIA.a \
    %{buildroot}%{nvidialibdir}/

# Install X driver and extension (is the nvidia_drv.o useful?)
%{__mkdir_p} %{buildroot}%{_libdir}/xorg/modules/drivers/
%{__install} -p -m 0755 usr/X11R6/lib/modules/drivers/nvidia_drv.so \
    %{buildroot}%{_libdir}/xorg/modules/drivers/
%{__mkdir_p} %{buildroot}%{_libdir}/xorg/modules/extensions/nvidia/
%{__install} -p -m 0755 usr/X11R6/lib/modules/extensions/libglx.so.%{nvversion} \
    %{buildroot}%{_libdir}/xorg/modules/extensions/nvidia/libglx.so
%{__install} -p -m 0755 usr/X11R6/lib/modules/libnvidia-wfb.so.%{nvversion} \
    %{buildroot}%{_libdir}/xorg/modules/libnvidia-wfb.so.%{nvversion}

# Install GL and tls libs
%{__mkdir_p} %{buildroot}%{nvidialibdir}/tls/
%{__install} -p -m 0755 usr/lib/*.so.%{nvversion} \
    %{buildroot}%{nvidialibdir}/
%{__install} -p -m 0755 usr/lib/tls/*.so.%{nvversion} \
    %{buildroot}%{nvidialibdir}/tls/

%ifarch x86_64
# Install 32bit compat GL and tls libs
%{__mkdir_p} %{buildroot}%{nvidialib32dir}/tls/
%{__install} -p -m 0755 usr/lib32/*.so.%{nvversion} \
    %{buildroot}%{nvidialib32dir}/
%{__install} -p -m 0755 usr/lib32/tls/*.so.%{nvversion} \
    %{buildroot}%{nvidialib32dir}/tls/
%endif

# Create .so symlinks
for libname in libGLcore libGL libnvidia-cfg libnvidia-tls tls/libnvidia-tls; do
    %{__ln_s} `basename ${libname}`.so.%{nvversion} \
        %{buildroot}%{nvidialibdir}/${libname}.so.1
    %{__ln_s} `basename ${libname}`.so.%{nvversion} \
        %{buildroot}%{nvidialibdir}/${libname}.so
done
%ifarch x86_64
for libname in libGLcore libGL libnvidia-cfg libnvidia-tls tls/libnvidia-tls; do
    %{__ln_s} `basename ${libname}`.so.%{nvversion} \
        %{buildroot}%{nvidialib32dir}/${libname}.so.1
    %{__ln_s} `basename ${libname}`.so.%{nvversion} \
        %{buildroot}%{nvidialib32dir}/${libname}.so
done
%endif

# Install useful nvidia tools
%{__mkdir_p} %{buildroot}%{_bindir}/
%{__install} -p -m 0755 usr/bin/{nvidia-bug-report.sh,nvidia-settings} \
    %{buildroot}%{_bindir}/
%{__mkdir_p} %{buildroot}%{_sbindir}/
%{__install} -p -m 0755 usr/bin/nvidia-xconfig \
    %{buildroot}%{_sbindir}/

# Install man pages (the other, nvidia-installer, isn't relevant)
%{__mkdir_p} %{buildroot}%{_mandir}/man1/
%{__install} -p -m 0644 usr/share/man/man1/nvidia-{settings,xconfig}* \
    %{buildroot}%{_mandir}/man1/

# Install pixmap for the desktop entry
%{__mkdir_p} %{buildroot}%{_datadir}/pixmaps/
%{__install} -p -m 0644 usr/share/pixmaps/nvidia-settings.png \
    %{buildroot}%{_datadir}/pixmaps/

# Remove "__UTILS_PATH__/" before the Exec command name
# Replace "__PIXMAP_PATH__/" with the proper pixmaps path
%{__perl} -pi -e 's|(Exec=).*/(.*)|$1$2|g;
                  s|(Icon=).*/(.*)|$1%{_datadir}/pixmaps/$2|g' \
    usr/share/applications/nvidia-settings.desktop

# Desktop entry for nvidia-settings
%{__mkdir_p} %{buildroot}%{_datadir}/applications/
desktop-file-install \
    --dir %{buildroot}/%{_datadir}/applications/ \
    --add-category System \
    --add-category Application \
    usr/share/applications/nvidia-settings.desktop

# Install modprobe.d file
%{__install} -D -p -m 0644 %{SOURCE205} \
    %{buildroot}%{_sysconfdir}/modprobe.d/nvidia

# Install ld.so.conf.d file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d/
echo %{nvidialibdir} >    %{buildroot}%{_sysconfdir}/ld.so.conf.d/nvidia.conf
%ifarch x86_64
echo %{nvidialib32dir} >> %{buildroot}%{_sysconfdir}/ld.so.conf.d/nvidia.conf
%endif

# Install profile.d files
%{__install} -D -p -m 0644 %{SOURCE202} \
    %{buildroot}%{_sysconfdir}/profile.d/nvidia.sh
%{__install} -D -p -m 0644 %{SOURCE203} \
    %{buildroot}%{_sysconfdir}/profile.d/nvidia.csh

# Install udev "configuration" file
%{__install} -D -p -m 0644 %{SOURCE206} \
    %{buildroot}%{_sysconfdir}/udev/makedev.d/51-nvidia.nodes


%clean
%{__rm} -rf %{buildroot}


%post
/sbin/ldconfig
# Add to DKMS registry
dkms add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root, 0755)
%doc LICENSE usr/share/doc/*
# Kernel and dkms related bits
%config %{_sysconfdir}/modprobe.d/nvidia
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
# udev "configuration"
%config %{_sysconfdir}/udev/makedev.d/51-nvidia.nodes
# Libraries and X modules
%config %{_sysconfdir}/ld.so.conf.d/nvidia.conf
%dir %{nvidialibdir}/
%{nvidialibdir}/*.so.*
%{nvidialibdir}/tls/
%{_libdir}/xorg/modules/drivers/nvidia_drv.so
%dir %{_libdir}/xorg/modules/extensions/nvidia/
%{_libdir}/xorg/modules/extensions/nvidia/libglx.so
%{_libdir}/xorg/modules/libnvidia-wfb.so.%{nvversion}
# Tools and utilities
%{_sysconfdir}/profile.d/*
%{_bindir}/*
%{_sbindir}/*
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_mandir}/man1/*
# Not needed devel but would violate the license not to include them
#files devel
#defattr(-,root,root,-)
%{nvidialibdir}/*.a
%{nvidialibdir}/*.so

%ifarch x86_64
%files 32bit
%defattr(-, root, root, 0755)
%dir %{nvidialib32dir}/
%{nvidialib32dir}/*.so.*
%{nvidialib32dir}/tls/
# Not needed devel but would violate the license not to include them
#files 32bit-devel
#defattr(-,root,root,-)
%{nvidialib32dir}/*.so
%endif

%changelog
* Sat Jul 24 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.27-1
- Version update
* Sun Nov 01 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.22-2
- Initial CCux package release for dkms
